#include <bits/stdc++.h>

using namespace std;

int zbir(int n, int m, int a[n][m], int xz, int yz){
    int x=0,y=0,s=0;
    while(x<n || y<m){
        s+=a[x][y];
        if(x<n && x+1!=xz){
            if(x+1==n){
                if(y+1!=yz){
                    x++;
                }
            }
            else{
                x++;
            }
        }
        if(y<m && y+1!=yz){
            if(y+1==m){
                if(x+1!=xz){
                    y++;
                }
            }
            else{
                y++;
            }
        }
    }
    return s;
}
int main()
{
    int n,m,q,xz,yz;
    cin>>n>>m;
    int a[n][m];
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>a[i][j];
        }
    }
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>xz>>yz;
        cout<<zbir(n,m,a,xz,yz)
    }
    return 0;
}